%define prefix -cvs
%define quicktime4linuxversion 2.0.4
%define ver 1.2.2
Name: cinelerra
Version: %ver
Release: alt0.M30.4
#%define _strip_skiplist %_libdir/cinelerra/*.plugin
%define _strip_skiplist %_libdir/cinelerra/*.so
# inline mmx assembly can cause text relocations
%set_verify_elf_method relaxed
Packager: Igor Vlasenko <viy@altlinux.org>

Summary: Complete production environment for audio and video.
Summary(ru_RU.KOI8-R):      
License: GPL
Group: Video
Icon: %name-48x48.xpm
#URL: http://www.heroinewarrior.com/cinelerra.php3
URL: http://cvs.cinerella.org
Provides: hvirtual = 1.0.0
Obsoletes: hvirtual

#Source: http://prdownloads.sourceforge.net/heroines/%name-%version-src.tar.bz2
Source: %{name}-%{version}%{prefix}.tar.bz2
#SourceCvs: cvs co -P -d:pserver:anoncvs@cvs.cinelerra.org:/var/lib/cvs/external/cinelerra
Source1: %name-16x16.xpm
Source2: %name-32x32.xpm
Source3: %name-48x48.xpm
# manually generated from debian/*.sgml
Source4: %name.1
Source5: mplexhi.1
Source6: mplexlo.1
Patch: quicktime-1.6-crashfix.patch
Patch1: guicast-alt-prelink-am.patch

%def_with chrpath
%if_with chrpath
BuildRequires: chrpath
%endif
BuildPreReq: libtheora-devel >= 1.0alpha4

# Automatically added by buildreq on Sun Oct 09 2005 (-ba)
BuildRequires: openexr-devel XFree86-devel XFree86-libs esound-devel ffmpeg-devel freetype2-devel gcc-c++ glib2 liba52-devel libalsa-devel libaudiofile-devel libavc1394-devel libdv-devel libe2fs-devel libfaad-devel libjpeg-devel liblame-devel libmjpegtools-devel libogg-devel libpng-devel libraw1394-devel libstdc++-devel libtheora-devel libtiff-devel libvorbis-devel nasm pkgconfig zlib-devel xvid-devel glib2-devel libfltk-devel cvs
#Removed manually: python-base python-modules-compiler python-modules-encodings rpm-build-python

%description
Cinelerra is a complete audio and video authoring
tool. It understands a lot of multimedia formats
(quicktime, avi, ogg) and audio/video compression
codecs (divx, xvid, mpeg1/2, ...)
.
It's about transforming the impossible into reality. The best program for 
video and audio manipulation. Install this, if you need editing and creating
video.

%description -l ru_RU.KOI8-R
     .
     ,   
 .      Linux - 
     .

%package -n libguicast
Version: %ver
Group: System/Libraries
Summary: A toolkit library
%description -n libguicast
 libguicast is a toolkit library mainly used by HeroineVirtual's
 softwares

%package -n libguicast-devel
Group: Development/C
Requires: libguicast = %version
Summary: A toolkit library
%description -n libguicast-devel
 libguicast is a toolkit library mainly used by HeroineVirtual's
 softwares
 .
 This package holds development files for the libguicast library

%package -n libsndfilehv
Group: System/Libraries
Summary: A custom modified Cinelerra's libsndfile library
%description -n libsndfilehv
 Custom modified Cinelerra's libsndfile library

%package -n libquicktimehv
Group: System/Libraries
Version: %quicktime4linuxversion
Summary: Quicktime 4 Linux Cinelerra internal library
%description -n libquicktimehv
 Quicktime 4 Linux was the first convenient way to read and write 
 uncompressed Quicktime movies on Linux. Today Quicktime 4 Linux 
 is intended for content creation and uncompressed movies. These 
 usually arise during the production phase and not the consumer 
 phase of a movie. It has improvements in colormodel support, 
 bit depth, accuracy, reliability, and codecs, while not 
 stressing economy. 
 .
 Users wishing for a consumer library should use OpenQuicktime or FFMPEG.
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libquicktimehv-devel
Group: Development/C
Version: %quicktime4linuxversion
Requires: libquicktimehv = %quicktime4linuxversion
Summary: Quicktime 4 Linux (Cinelerra internal) library (development files)
%description -n libquicktimehv-devel
 Quicktime 4 Linux was the first convenient way to read and write 
 uncompressed Quicktime movies on Linux. Today Quicktime 4 Linux 
 is intended for content creation and uncompressed movies. These 
 usually arise during the production phase and not the consumer 
 phase of a movie. It has improvements in colormodel support, 
 bit depth, accuracy, reliability, and codecs, while not 
 stressing economy. 
 .
 Users wishing for a consumer library should use OpenQuicktime or FFMPEG.
 .
 This package holds development files for the Quicktime 4 Linux library
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libmpeg3hv
Version: %ver
Group: System/Libraries
Summary: advanced editing and manipulation of MPEG streams (cinelerra's internal) 
%description -n libmpeg3hv
 Libmpeg3 supports advanced editing and manipulation of MPEG streams. 
 MPEG is normally a last mile format but with libmpeg3 you can edit 
 it like a first mile solution. 
 .
 Unless you have a need for MPEG editing and copying, you're better 
 off using a consumer library like FFMPEG.
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libmpeg3hv-devel
Group: Development/C
Requires: libmpeg3hv = %version
Summary: advanced editing and manipulation of MPEG streams (development files)
%description -n libmpeg3hv-devel
 Libmpeg3 supports advanced editing and manipulation of MPEG streams. 
 MPEG is normally a last mile format but with libmpeg3 you can edit 
 it like a first mile solution. 
 .
 Unless you have a need for MPEG editing and copying, you're better 
 off using a consumer library like FFMPEG.
 .
 This package holds development files for the libmpeg3 library
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libmpeg3hv-utils
Group: Video
Requires: libmpeg3hv = %version
Summary: advanced editing and manipulation of MPEG streams (development files)
%description -n libmpeg3hv-utils
Libmpeg3 supports advanced editing and manipulation of MPEG streams. 
MPEG is normally a last mile format but with libmpeg3 you can edit 
it like a first mile solution. 
.
Unless you have a need for MPEG editing and copying, you're better 
off using a consumer library like FFMPEG.
.
This package holds utilities for the libmpeg3 library
.
For more informations, see http://heroinewarrior.com/quicktime.php3


%prep
%setup -q -n %name-%version
%patch -p0 
%patch1 -p0 

%build
autoreconf -fisv

CONFFLAGS=

%ifarch athlon
  CONFFLAGS="$CONFFLAGS --enable-3dnow"
  %add_optflags -m3dnow
%endif
%ifarch i586
  %remove_optflags -march=i586 -mtune=i686 -mcpu=i686
# anyway, it'll not run on p133/64mb -- p4/1GB is recommended :( 
# furthermore, on old garbage like pmmx/pII/k6 we really need ALL optimizations
  %add_optflags -march=pentium-mmx -mtune=i686
%endif

%ifarch powerpc
%else
  %define _optlevel 3
  %add_optflags -ffast-math -mmmx -minline-all-stringops -fprefetch-loop-arrays -funroll-loops
  %add_optflags %optflags_kernel
  #add_optflags -msse -m3dnow # athlonXP
  #add_optflags -msse -msse2 # p4
  CXXFLAGS="%optflags -fno-check-new"
  %ifarch ix86
   CONFFLAGS="$CONFFLAGS --enable-mmx --enable-x86"
   # uncomment --without-pic if build fails with --enable-x86 --enable-mmx
   # CONFFLAGS="$CONFFLAGS --without-pic"
  %endif
%endif

%configure $CONFFLAGS

%make_build 

%install
%makeinstall

%if_with chrpath
chrpath -d $RPM_BUILD_ROOT%_libdir/libguicast.so.?.?.?
%endif

# hack to properly build foreign guicast
cp quicktime/colormodels.h $RPM_BUILD_ROOT%_includedir/quicktime
cp quicktime/libdv.h $RPM_BUILD_ROOT%_includedir/quicktime

# it is for ``official'' cinelerra only
#rm -rf doc/.xvpics plugins/titler/fonts/CVS doc/CVS
#export ARCH="`/bin/uname --machine`"
#%__install -d -m755 $RPM_BUILD_ROOT/%_libdir/cinelerra/fonts
#%__install -d -m755 $RPM_BUILD_ROOT/%_bindir
#%__install -s -m755 cinelerra/$ARCH/cinelerra $RPM_BUILD_ROOT/%_bindir
#%__install -m755 plugins/$ARCH/*.plugin $RPM_BUILD_ROOT/%_libdir/cinelerra
#%__install -m644 plugins/titler/fonts/* $RPM_BUILD_ROOT/%_libdir/cinelerra/fonts

# Install icons
%__install -D -m 644 %SOURCE1 $RPM_BUILD_ROOT%_miconsdir/%name.xpm
%__install -D -m 644 %SOURCE2 $RPM_BUILD_ROOT%_iconsdir/%name.xpm
%__install -D -m 644 %SOURCE3 $RPM_BUILD_ROOT%_liconsdir/%name.xpm
# replacing with new native icon
%__mv $RPM_BUILD_ROOT/usr/share/pixmaps/cinelerra.xpm $RPM_BUILD_ROOT%_liconsdir/%name.xpm


# menu support
%__install -d $RPM_BUILD_ROOT%_menudir
cat << EOF > $RPM_BUILD_ROOT%_menudir/%name
?package(%name): longtitle="%summary" \
command="%_bindir/%name" title="%name"  needs="x11" \
section="Multimedia/Video" \
icon="%name.xpm"
EOF

# man pages
%__install -d -m 755 $RPM_BUILD_ROOT%_man1dir
%__install -D -m 644 %SOURCE4 %SOURCE5 %SOURCE6 $RPM_BUILD_ROOT%_man1dir

#fixing *hv-flavour
mv $RPM_BUILD_ROOT%_includedir/mpeg3 $RPM_BUILD_ROOT%_includedir/mpeg3hv 
mv $RPM_BUILD_ROOT%_includedir/quicktime $RPM_BUILD_ROOT%_includedir/quicktimehv 
pushd $RPM_BUILD_ROOT%_includedir; %__ln_s quicktimehv quicktime; popd

# libguicast-devel
%__install -d -m755 $RPM_BUILD_ROOT/%_includedir/guicast
%__install -m644 guicast/*.h guicast/*.inc $RPM_BUILD_ROOT/%_includedir/guicast

%{find_lang} %{name}

%post
%update_menus

%postun
%clean_menus

%files -f %{name}.lang
%doc doc/*
%dir %_libdir/cinelerra
%dir %_libdir/cinelerra/fonts
%_bindir/cinelerra
%_bindir/mplexlo
%_bindir/mplexhi
# %_libdir/cinelerra/*.plugin
%_libdir/cinelerra/*.so
%_libdir/cinelerra/*.la
#%_libdir/cinelerra/fonts/*
%_libdir/cinelerra/shapewipe
%_miconsdir/%name.xpm
%_iconsdir/%name.xpm
%_liconsdir/%name.xpm
%_menudir/%name
%_man1dir/*

%files -n libsndfilehv
%_libdir/libsndfile*.so*

%files -n libguicast
%_libdir/libguicast.so.?*

%files -n libguicast-devel
%_libdir/libguicast.so
%_includedir/guicast

%files -n libmpeg3hv-devel
%docdir libmpeg3/docs
%_libdir/libmpeg3hv.*
%_includedir/mpeg3hv/*

%files -n libmpeg3hv
%_libdir/libmpeg3hv-*.so*

%files -n libmpeg3hv-utils
%_bindir/mpeg*

%files -n libquicktimehv-devel
%docdir quicktime/docs
%_libdir/libquicktimehv.*
#%%_includedir/quicktimehv/*
%_includedir/quicktime
%_includedir/quicktimehv/quicktime.h
%_includedir/quicktimehv/qtprivate.h
%_includedir/quicktimehv/colormodels.h
%_includedir/quicktimehv/libdv.h


%files -n libquicktimehv
%_libdir/libquicktimehv-*.so*


%changelog
* Fri Mar 24 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt0.M30.4
- backport for M30

* Fri Mar 24 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt4
- removed useless rpath with chrpath

* Sun Feb 05 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt3
- prelink support with guicast-alt-prelink-am.patch
- ifarch ix86 for x86_64 support

* Mon Nov 21 2005 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt2
- added /usr/include/quicktime to libquicktimehv-devel
- added colormodels.h & libdv.h to libquicktimehv-devel
- fixed russian Summary && description

* Fri Oct 28 2005 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt1
- removed phantom python build dependencies

* Mon Oct 10 2005 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt0.9
- picked up from orphaned;
- new version;
- new build process based on ``unofficial'' cvs.cinelerra.org
- my patch for Minolta Z3
- split into packages

* Fri Sep 12 2003 Alexander Belov <asbel@altlinux.ru> 1.1.7-alt1
- New version
- Added koi8 russian description and summary to package
- New BuildRequires

* Tue May 20 2003 Alexander Belov <asbel@altlinux.ru> 1.1.6-alt2
- Fixed instalation bug

* Fri May 16 2003 Alexander Belov <asbel@altlinux.ru> 1.1.6-alt1
- New version and new name of package

* Wed Oct 23 2002 AEN <aen@altlinux.ru> 1.0.0-alt2
- first build for Sisyphus, thnx to Alexander Belov!
- MS fonts removed

* Wed Oct 16 2002 Alexander Belov <asbel@mail.ru> 1.0.0-alt1
- Initial release
